#!/usr/bin/perl -w
#
use strict;

my ($GENOME_FILE)=$ARGV[0];
my ($PRE_LOC)=$ARGV[1];

my $chrm="";
my %chrm_seq;
my $seq_extend=200;

open(Seq,"$GENOME_FILE") || die;	
while(<Seq>){
	if(/>chr[0]?(\d+)/){
		$chrm=$1;
		next;
	}
	if(/(\S+)/){
		my $cur_seq=$1;
		$chrm_seq{$chrm}{"seq"}.=uc($cur_seq);
		$chrm_seq{$chrm}{"len"}+=length($cur_seq);
	}
}
close(Seq);

open (Pre,"$PRE_LOC") || die;
while(<Pre>){
	if(/^(\S+).*chr(\S+)\s+(\d+)\s+(\d+)\s+([+-])/){
		my ($name,$chrm,$ln,$rn,$strand)=($1,$2,$3,$4,$5);
		my $pre_seq=seq_sub($chrm,$ln-$seq_extend,$rn+$seq_extend,$strand);
		print ">$name\n",$pre_seq,"\n";
	}
}
close(Pre);

#--------------------

sub seq_sub{
	my ($chrm,$st,$end,$strand)=@_;
	my $seq=substr($chrm_seq{$chrm}{"seq"},$st-1,$end-$st+1);
	$seq=revcompl($seq) if ($strand eq "-");
	return ($seq);
}

#--------------------

sub revcompl{
	my ($s)=@_;
	$s=reverse($s);
	$s=~tr/atgcATGCU/tacgTACGA/;
	return($s);
}

#--------------------
