#!/usr/bin/perl -w

use strict;

my ($GENOME_MAP_FILE)=$ARGV[0];
my ($NCRNA_MAP_FILE)=$ARGV[1];
my ($SEQ_FILE)=$ARGV[2];
my ($RETAINED_MAP_FILE)=$ARGV[3];
my ($RETAINED_SEQ_FILE)=$ARGV[4];

my $max_loci=20;
my $min_count=10;
my %nc_hits;
my %retain_reads;
open (Nc_map,"$NCRNA_MAP_FILE") || die;
while(<Nc_map>){
	if(/^(\S+)/){
		my $cur_name=$1;
		$nc_hits{$cur_name}=1;
	}
}
close(Nc_map);

open (Map_out,">$RETAINED_MAP_FILE");
open (Gn_map,"$GENOME_MAP_FILE") || die;
while(<Gn_map>){
	if(/^(\S+\-(\S+)).*\s+(\d+)/){
		my ($read_name,$read_count,$read_loci)=($1,$2,$3);
		next if ($nc_hits{$read_name});
		print Map_out $_ if (($read_count>=$min_count) && (($read_loci+1)<=$max_loci));
		$retain_reads{$read_name}=1 if (($read_loci+1)<=$max_loci);
	}
}
close(Gn_map);
close(Map_out);

open (Seq_file,"$SEQ_FILE") || die;
open (Retain_seq,">$RETAINED_SEQ_FILE");
my $ck=0;
while(<Seq_file>){
	if(/>(\S+)/){
		my $seq_name=$1;
		$ck=0;
		$ck=1 if ($retain_reads{$seq_name});
	}
	print Retain_seq $_ if ($ck);
}
close(Seq_file);
close(Retain_seq);

